//
//                 AVRMP3Car - Standalone MP3-Player
//                          Version 2.00 - experimental!   
// written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
//
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation - version 2.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License in file COPYING for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//Please report any bug/fix, modification, suggestion to
//
//           skymab@gmx.de
//
//--------------------------------------------------------------------
#include <io.h>
#include "global.h"
#include "ide.h"
#include "lcd240.h"
#include "fat32.h"
#include "system.h"
#include "dir.h"
#include "key.h"

extern unsigned char SektorBuffer [512];

extern long unsigned int VAR_FAT32_RsvdSecCnt;
extern long unsigned int VAR_FAT32_NumOfFats;
extern long unsigned int VAR_FAT32_FatSize;
extern long unsigned int VAR_FAT32_SPC;
extern long unsigned int VAR_FAT32_RootCluster;
extern long unsigned int VAR_FAT32_FirstDSector;

long unsigned int *DIR_LongWordPointer;
long unsigned int *DIR_SelectedFilePointer;

unsigned char *DIR_CharPointer1;
unsigned char *DIR_CharPointer2;

unsigned char DIR_LastLFN = 0x00;

unsigned int  DIR_WorkOfs = 0x0000;
unsigned int  DIR_CopyOfWorkOfs = 0x0000;
unsigned int  DIR_VAR_MenuEntries = 0x0000;

unsigned int  DIR_Menu_YPos=0x0000;
unsigned int  DIR_Menu_Page=0x0000;

/*-------------------------------------------------------------------
       DIR_Up
-------------------------------------------------------------------*/
void DIR_Up(void)
{
    if ((DIR_Menu_YPos+DIR_Menu_Page)>0)
    {
        if (DIR_Menu_YPos>0x00)
        {
            LCD240_ClearBar(DIR_Menu_YPos);
            DIR_Menu_YPos-=0x01;
            LCD240_DisplayBar(DIR_Menu_YPos);
        }
        else
        {
            DIR_Menu_Page-=0x01;
            DIR_DisplayDir();
        }
    }
}

/*-------------------------------------------------------------------
       DIR_Down
-------------------------------------------------------------------*/
void DIR_Down(void)
{
    if ((DIR_Menu_YPos+DIR_Menu_Page)<(DIR_VAR_MenuEntries-1))
    {
        if (DIR_Menu_YPos<0x05)
        {
            LCD240_ClearBar(DIR_Menu_YPos);
            DIR_Menu_YPos+=0x01;
            LCD240_DisplayBar(DIR_Menu_YPos);
        }
        else
        {
            DIR_Menu_Page+=0x01;
            DIR_DisplayDir();
        }
    }
}

/*-------------------------------------------------------------------
       DIR_EventLoop
-------------------------------------------------------------------*/
void DIR_EventLoop (void)
{

unsigned char PressedKey = KEY_None;
long unsigned int LongWord = 0x00000000;
unsigned int WorkCounter = 0x0000;
//    LCD240_ClearText();
    DIR_DisplayDir();
    LCD240_DisplayBar(DIR_Menu_YPos);
    while (1==1)
    {
        PressedKey = KEY_WaitForKey();

        if (PressedKey == KEY_Up)
            DIR_Up();

        if (PressedKey == KEY_Down)
            DIR_Down();


        if (PressedKey == KEY_PageUp)
            for (WorkCounter=0x0000; WorkCounter<5; WorkCounter+=1)
                DIR_Up();

        if (PressedKey == KEY_PageDown)
            for (WorkCounter=0x0000; WorkCounter<5; WorkCounter+=1)
                DIR_Down();

        if (PressedKey == KEY_Return)
        {
            (int) DIR_CharPointer1 = ((int) 0x1000)+((DIR_Menu_YPos+DIR_Menu_Page)*50)+OFS_EDIR_Attr;
            if ((*DIR_CharPointer1 & 0x10) != 0)
            {
                (int) DIR_LongWordPointer = ((int) 0x1000)+((DIR_Menu_YPos+DIR_Menu_Page)*50)+OFS_EDIR_Cluster;
//                LCD240_ClearText();
                LCD240_ClearBar(DIR_Menu_YPos);
                LongWord = *DIR_LongWordPointer;
                DIR_Read(LongWord);
                DIR_Menu_YPos = 0x0000;
                DIR_Menu_Page = 0x0000;
                DIR_DisplayDir();
                LCD240_DisplayBar(DIR_Menu_YPos);
            }
            else
            {
                (int) DIR_SelectedFilePointer = ((int) 0x1000)+((DIR_Menu_YPos+DIR_Menu_Page)*50); //+OFS_EDIR_Cluster;
                break;
            }
        }

        if (PressedKey == KEY_Ok)
            break;
    }
}

/*-------------------------------------------------------------------
       DIR_DisplayDir
-------------------------------------------------------------------*/
void DIR_DisplayDir(void)
{

unsigned int WorkCounter1 = 0x0000;
unsigned int WorkCounter2 = 0x0000;
unsigned char *CharPointer;

    for (WorkCounter1=0x0000; WorkCounter1<6; WorkCounter1+=1)
    {
        (int) CharPointer = ((int) 0x1000) + ((DIR_Menu_Page+WorkCounter1)*50);    // Externer Speicherbereich
        LCD240_SetCursor(0,WorkCounter1);
        for (WorkCounter2=0x0000; WorkCounter2<40; WorkCounter2+=1)
        {
            LCD240_OutAscii(*CharPointer);
            CharPointer+=1;
        }
    }
}

/*-------------------------------------------------------------------
       DIR_Clear
-------------------------------------------------------------------*/
void DIR_Clear(void)
{

unsigned int WorkCounter;

    (int) DIR_CharPointer1 = (int) 0x1000;    // Externer Speicherbereich

    for (WorkCounter=0x0000; WorkCounter<0x6fc0; WorkCounter+=1)
    {
        *DIR_CharPointer1 = 0x20;
        DIR_CharPointer1+=1;
    }
    DIR_VAR_MenuEntries = 0x0000;
}

/*-------------------------------------------------------------------
       DIR_Read
-------------------------------------------------------------------*/
void DIR_Read(long unsigned int ClusterNr)
{

long unsigned int LastDirCluster;
long unsigned int DirSector = 0x00000000;
unsigned char SectorInCluster = 0x00;

    if (ClusterNr==0x00000000)
        ClusterNr = VAR_FAT32_RootCluster;

    LastDirCluster = ClusterNr;
    DIR_LastLFN = 0;

    DIR_Clear();

    (int) DIR_CharPointer1 = (int) 0x1000;    // Externer Speicherbereich

    while ((LastDirCluster & 0x0ffffff0) != 0x0ffffff0)
    {
        DirSector = FAT32_GetFirstSectorofCluster(LastDirCluster);

        SectorInCluster=0;

        while (SectorInCluster<VAR_FAT32_SPC)
        {
            IDE_ReadLBA(0x01, DirSector, SektorBuffer);
            DIR_ScanDirSector ();
            DirSector+=1;
            SectorInCluster+=1;
        }

        LastDirCluster = FAT32_GetNextCluster(ClusterNr);
    }
}

/*-------------------------------------------------------------------
       DIR_SCAN_DIRSECTOR
-------------------------------------------------------------------*/
void DIR_ScanDirSector(void)
{

/* DIR_SCAN_DIRSECTOR_0 */

    DIR_WorkOfs = 0x0000;

    while (((int) DIR_CharPointer1 < (int) 0x7fc0) && (DIR_WorkOfs<512))
    {
        if ((SektorBuffer[DIR_WorkOfs] != 0xe5) && (SektorBuffer[DIR_WorkOfs] != 0x00))
        {
            if (SektorBuffer[DIR_WorkOfs+OFS_DIR_Attribute] == 0x0f)
                DIR_ScanDirSectorLFN();
            else
            {
                DIR_ScanDirSectorNormal();
                DIR_CharPointer1+=50;
                DIR_VAR_MenuEntries+=1;
            }

        }
        DIR_WorkOfs=DIR_WorkOfs+0x20;                  // Jeder Eintrag 32Bytes lang
    }
}

/*-------------------------------------------------------------------
       DIR_SCAN_DIRSECTOR_sub1
-------------------------------------------------------------------*/
void DIR_ScanDirSectorLFN_Sub1(unsigned int NumOfBytes)
{

int WorkCounter = 0x0000;
unsigned char WorkByte = 0x00;


    WorkCounter = 0x0000;


    while (WorkCounter<NumOfBytes)
    {
        WorkByte = SektorBuffer[DIR_CopyOfWorkOfs];
        if ((WorkByte==0x00) || (WorkByte==0xff))
            WorkByte=0x20;

        if (((int) DIR_CharPointer2 - (int) DIR_CharPointer1) <40)
        {
            *DIR_CharPointer2 = WorkByte;
        }

        DIR_CharPointer2+=1;               // OFS um 1 erhhen
        DIR_CopyOfWorkOfs+=2;
        WorkCounter+=1;
    }
}

/*-------------------------------------------------------------------
       DIR_SCAN_DIRSECTOR
-------------------------------------------------------------------*/
void DIR_ScanDirSectorLFN(void)
{

unsigned char LFNOffset = 0x00;
                                        // Anzahl der Long-Name-Sequenzen
    DIR_CopyOfWorkOfs = DIR_WorkOfs;

    LFNOffset = SektorBuffer[DIR_CopyOfWorkOfs] & 0x3f;
    LFNOffset-=1;

    (int) DIR_CharPointer2 = (int) DIR_CharPointer1 + (LFNOffset * 13);

    DIR_CopyOfWorkOfs+=1;
    DIR_ScanDirSectorLFN_Sub1(0x05);
    DIR_CopyOfWorkOfs+=3;
    DIR_ScanDirSectorLFN_Sub1(0x06);
    DIR_CopyOfWorkOfs+=2;
    DIR_ScanDirSectorLFN_Sub1(0x02);

    DIR_LastLFN = 0x01;
}

/*-------------------------------------------------------------------
       DIR_SCAN_DIRSECTOR
-------------------------------------------------------------------*/
void DIR_ScanDirSectorNormal(void)
{

unsigned int WorkCounter = 0x0000;

    (int) DIR_CharPointer2 = (int) DIR_CharPointer1;

    if (DIR_LastLFN == 0)
    {
        for (WorkCounter=0x0000; WorkCounter<11; WorkCounter+=1)
        {
            *DIR_CharPointer2 = SektorBuffer[DIR_WorkOfs+WorkCounter];
            DIR_CharPointer2+=1;
        }
    }

    (int) DIR_CharPointer2 = (int) DIR_CharPointer1 + OFS_EDIR_Size;
    for (WorkCounter=0x0000; WorkCounter<4; WorkCounter+=1)
    {
        *DIR_CharPointer2 = SektorBuffer[DIR_WorkOfs+WorkCounter+OFS_DIR_Size];
        DIR_CharPointer2+=1;
    }

    (int) DIR_CharPointer2 = (int) DIR_CharPointer1 + OFS_EDIR_Cluster;
    for (WorkCounter=0x0000; WorkCounter<2; WorkCounter+=1)
    {
        *DIR_CharPointer2 = SektorBuffer[DIR_WorkOfs+WorkCounter+OFS_DIR_ClusterLO];
        DIR_CharPointer2+=1;
    }

    for (WorkCounter=0x0000; WorkCounter<2; WorkCounter+=1)
    {
        *DIR_CharPointer2 = SektorBuffer[DIR_WorkOfs+WorkCounter+OFS_DIR_ClusterHI];
        DIR_CharPointer2+=1;
    }

    (int) DIR_CharPointer2 = (int) DIR_CharPointer1 + OFS_EDIR_Attr;
    *DIR_CharPointer2 = SektorBuffer[DIR_WorkOfs+OFS_DIR_Attr];

    DIR_LastLFN = 0x00;
}

