//
//                 AVRMP3Car - Standalone MP3-Player
//                          Version 2.00 - experimental!   
// written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
//
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation - version 2.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License in file COPYING for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//Please report any bug/fix, modification, suggestion to
//
//           skymab@gmx.de
//
//--------------------------------------------------------------------
#include <io.h>
#include "global.h"
#include "ide.h"
#include "lcd240.h"
#include "fat32.h"
#include "system.h"
#include "dir.h"

extern unsigned char SektorBuffer [512];

long unsigned int VAR_FAT32_RsvdSecCnt  = 0x00000000;
long unsigned int VAR_FAT32_NumOfFats   = 0x00000000;
long unsigned int VAR_FAT32_FatSize     = 0x00000000;
long unsigned int VAR_FAT32_SPC         = 0x00000000;
long unsigned int VAR_FAT32_RootCluster = 0x00000000;
long unsigned int VAR_FAT32_FirstDSector= 0x00000000;

/*-------------------------------------------------------------------
 FAT32_Get_First_Sector_of_Cluster

 First-Sec-Of-Clus, Cluster in Cluster

 IRAM_First_Sec_Of_Clus= ((N-2)*BPB_SecPerClus) + FirstDataSector
-------------------------------------------------------------------*/
long unsigned int FAT32_GetFirstSectorofCluster(long unsigned int ClusterNr)
{

long unsigned LongWord = 0x00000000;

    LongWord = ((ClusterNr-2)* VAR_FAT32_SPC) + VAR_FAT32_FirstDSector;

    return LongWord;
}

/*-------------------------------------------------------------------
 FAT32_GET_NEXT_CLUSTER
 Holt aus der FAT den nchsten Cluster raus IRAM_NEXT_CLUSTER
 und IRAM_CLUSTER

 ThisFatSecNr= RsvdSecCnt+ (FatOffset / 512) + 63
 ThisFatEntOfs= Restvon (FatOffset /512) + Bufferoffset

-------------------------------------------------------------------*/
long unsigned int FAT32_GetNextCluster(long unsigned int NextCluster)
{

long unsigned int FatSecNum = 0x00000000;
long unsigned int FatEntOfs = 0x00000000;
long unsigned int FatOffset = 0x00000000;
long unsigned int ClusterNr = 0x00000000;
long unsigned int *ClusterPTR;
unsigned char *BytePTR;

    FatOffset = NextCluster * 4;

    FatSecNum = VAR_FAT32_RsvdSecCnt + (FatOffset / 512) + 63;

    IDE_ReadLBA(0x01, FatSecNum, SektorBuffer);

    (int) BytePTR = (int)&SektorBuffer + (int) (FatOffset % 512);
    (int) ClusterPTR = (int) BytePTR;
    ClusterNr = *ClusterPTR;

    return ClusterNr;

}

/*-------------------------------------------------------------------
       FAT32_ReadBPB
-------------------------------------------------------------------*/
void FAT32_ReadBPB(void)
{
    IDE_ReadLBA(0x01, 0x0000003f, SektorBuffer);

    if (SektorBuffer[OFS_FAT32_BPS+1] != 0x02)
    {
        SYSTEM_HALT ("illegal Value of 'Bytes per Sector'!");
    }

    VAR_FAT32_RsvdSecCnt  = (SektorBuffer[OFS_FAT32_RSVDSECCNT])+
                            (SektorBuffer[OFS_FAT32_RSVDSECCNT+1]<<8);

    VAR_FAT32_NumOfFats   = SektorBuffer[OFS_FAT32_NUMOFFATS];

    VAR_FAT32_FatSize     = ((long) SektorBuffer[OFS_FAT32_FATSIZE])+
                            ((long) SektorBuffer[OFS_FAT32_FATSIZE+1]<<8)+
                            ((long) SektorBuffer[OFS_FAT32_FATSIZE+2]<<16)+
                            ((long) SektorBuffer[OFS_FAT32_FATSIZE+3]<<24);

    VAR_FAT32_SPC         = SektorBuffer[OFS_FAT32_SPC];

    VAR_FAT32_RootCluster = ((long) SektorBuffer[OFS_FAT32_ROOTCLUSTER])+
                            ((long) SektorBuffer[OFS_FAT32_ROOTCLUSTER+1]<<8)+
                            ((long) SektorBuffer[OFS_FAT32_ROOTCLUSTER+2]<<16)+
                            ((long) SektorBuffer[OFS_FAT32_ROOTCLUSTER+3]<<24);

    VAR_FAT32_FirstDSector = VAR_FAT32_NumOfFats * VAR_FAT32_FatSize;

    VAR_FAT32_FirstDSector+= VAR_FAT32_RsvdSecCnt + 63;

    DIR_Read(VAR_FAT32_RootCluster);
}

