//
//                 AVRMP3Car - Standalone MP3-Player
//                          Version 2.00 - experimental!   
// written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
//
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation - version 2.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License in file COPYING for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//Please report any bug/fix, modification, suggestion to
//
//           skymab@gmx.de
//
//--------------------------------------------------------------------
#include <io.h>
#include "global.h"
#include "ide.h"
#include "lcd240.h"
#include "mp3dec.h"

unsigned char SektorBuffer [512];
long unsigned int IDE_LBA = 0x00000000;
char *P_IDE_Adr;

/*-------------------------------------------------------------------
 IDE_WaitForReady
-------------------------------------------------------------------*/
void IDE_WaitForReady(void)
{

unsigned char WorkByte= 0x00;

test1:

    (int) P_IDE_Adr = (int) TIDE_STATUS;// Ntigen Pointer erstellen
    WorkByte = *P_IDE_Adr;
    if ((WorkByte & 0x40) != 0) goto ende;
    goto test1;

ende:

}

/*-------------------------------------------------------------------
 IDE_WaitWhileBusy
-------------------------------------------------------------------*/
void IDE_WaitWhileBusy(void)
{

unsigned char WorkByte=0x00;

test1:

    (int) P_IDE_Adr = (int) TIDE_STATUS;// Ntigen Pointer erstellen
    WorkByte = *P_IDE_Adr;
    if ((WorkByte & 0x80) == 0) goto ende;
    goto test1;

ende:
}

/*-------------------------------------------------------------------
 IDE_WaitForDRQ
-------------------------------------------------------------------*/
void IDE_WaitForDRQ(void)
{

unsigned char WorkByte = 0;

test1:

    (int) P_IDE_Adr = (int) TIDE_STATUS;// Ntigen Pointer erstellen
    WorkByte = *P_IDE_Adr;
    if ((WorkByte & 0x08) != 0) goto ende;
    goto test1;

ende:
}

/*-------------------------------------------------------------------
 IDE_CheckDRQ
-------------------------------------------------------------------*/
unsigned int IDE_CheckDRQ(void)
{
    (int) P_IDE_Adr = (int) TIDE_STATUS;// Ntigen Pointer erstellen

    return (*P_IDE_Adr & 0x08);         // Maskieren und zurckgeben
}

/*-------------------------------------------------------------------
 IDE_STANDBY
-------------------------------------------------------------------*/
void IDE_Standby(void)
{
    IDE_WaitWhileBusy ();
    IDE_WaitForReady ();

    (int) P_IDE_Adr = (int) TIDE_DRVHEAD;
    *P_IDE_Adr = 0xe0;

    (int) P_IDE_Adr = (int) TIDE_COMMAND;
    *P_IDE_Adr = 0xe0;

    IDE_WaitWhileBusy ();
}

/*-------------------------------------------------------------------
 IDE_IDLE
-------------------------------------------------------------------*/
void IDE_Idle(void)
{
    IDE_WaitWhileBusy ();
    IDE_WaitForReady ();

    (int) P_IDE_Adr = (int) TIDE_DRVHEAD;
    *P_IDE_Adr = 0xe0;

    (int) P_IDE_Adr = (int) TIDE_COMMAND;
    *P_IDE_Adr = 0xe1;

    IDE_WaitWhileBusy ();
}

/*-------------------------------------------------------------------
 IDE_SEEK      X:CYLINDER
-------------------------------------------------------------------*/
void IDE_Seek(unsigned int CylNumber)
{
    IDE_WaitWhileBusy();
    IDE_WaitForReady();

    (int) P_IDE_Adr = (int) TIDE_CYLLOW;
    *P_IDE_Adr = (CylNumber & 0x00ff);

    (int) P_IDE_Adr = (int) TIDE_CYLHI;
    *P_IDE_Adr = (CylNumber & 0xff00) >> 8;

    (int) P_IDE_Adr = (int) TIDE_DRVHEAD;
    *P_IDE_Adr = 0xe0;

    (int) P_IDE_Adr = (int) TIDE_COMMAND;
    *P_IDE_Adr = 0x70;

    IDE_WaitForReady();
    IDE_WaitWhileBusy();
}


/*-------------------------------------------------------------------
 IDE_Autodetect
-------------------------------------------------------------------*/
void IDE_Autodetect(void)
{

unsigned int WorkWord = 0x0000;

    LCD240_ClearText();
    LCD240_OutStringXY(5,3,"Autodetection in progress...");

    (int) P_IDE_Adr = (int) TIDE_DRVHEAD;
    *P_IDE_Adr = 0xe0;

    IDE_WaitWhileBusy();
    IDE_WaitForReady();

    (int) P_IDE_Adr = (int) TIDE_DRVHEAD;
    *P_IDE_Adr = 0xe0;              // Master und LBA

    (int) P_IDE_Adr = (int) TIDE_COMMAND;
    *P_IDE_Adr = 0xec;              // Autodetectfunktion

    IDE_WaitForDRQ();

    for (WorkWord=0; WorkWord<512; WorkWord=WorkWord)
    {
        (int) P_IDE_Adr = (int) TIDE_DATAREGLO;
        SektorBuffer[WorkWord+1] = *P_IDE_Adr;

        (int) P_IDE_Adr = (int) TIDE_DATAREGHI;
        SektorBuffer[WorkWord] = *P_IDE_Adr;

        WorkWord+=2;
    }

    IDE_WaitWhileBusy();
    IDE_WaitForReady();

//    LCD240_OutStringXY(0,0,&SektorBuffer[54]);
    LCD240_ClearText();
}

/*-------------------------------------------------------------------
 IDE_READ_LBA     r16=Anzahl der Sektoren  X=BufferAdresse
-------------------------------------------------------------------*/
void IDE_ReadLBA(unsigned char NumOfSek,
                 long unsigned int LBA_Adress,
                 unsigned char *Buffer)
{

//int WorkCounter1 = 0;
int WorkCounter2 = 0;

    IDE_WaitWhileBusy ();
    IDE_WaitForReady ();

    (int) P_IDE_Adr = (int) TIDE_SECCNT;
    *P_IDE_Adr = NumOfSek;

    (int) P_IDE_Adr = (int) TIDE_SECNR;
    *P_IDE_Adr = (LBA_Adress & 0x000000ff);

    (int) P_IDE_Adr = (int) TIDE_CYLLOW;
    *P_IDE_Adr = ((LBA_Adress & 0x0000ff00) >> 8);

    (int) P_IDE_Adr = (int) TIDE_CYLHI;
    *P_IDE_Adr = ((LBA_Adress & 0x00ff0000) >> 16);

    (int) P_IDE_Adr = (int) TIDE_DRVHEAD;
    *P_IDE_Adr = (((LBA_Adress & 0xff000000) >> 24) | 0xe0);

    (int) P_IDE_Adr = (int) TIDE_COMMAND;
    *P_IDE_Adr = 0x20;

//    WorkCounter1=(int) NumOfSek;
//    while (WorkCounter1>=0)
//    {
        IDE_WaitForDRQ();
        WorkCounter2 = 0;
        while (WorkCounter2<512)
        {
            (int) P_IDE_Adr = (int) TIDE_DATAREGLO;
            *Buffer = *P_IDE_Adr;
            Buffer+=1;

            (int) P_IDE_Adr = (int) TIDE_DATAREGHI;
            *Buffer = *P_IDE_Adr;
            Buffer+=1;

            WorkCounter2+=2;
        }
//        WorkCounter1=WorkCounter1-1;
//    }

    IDE_WaitWhileBusy();
    IDE_WaitForReady();
}

/*-------------------------------------------------------------------
 IDE_READ_LBA     r16=Anzahl der Sektoren  X=BufferAdresse
-------------------------------------------------------------------*/
void IDE_ReadLBAAndPlay(unsigned char NumOfSek,
                        long unsigned int LBA_Adress)
{

//int WorkCounter1 = 0;
int WorkCounter2 = 0;
unsigned int WorkWord = 0x0000;

    IDE_WaitWhileBusy ();
    IDE_WaitForReady ();

    (int) P_IDE_Adr = (int) TIDE_SECCNT;
    *P_IDE_Adr = NumOfSek;

    (int) P_IDE_Adr = (int) TIDE_SECNR;
    *P_IDE_Adr = (LBA_Adress & 0x000000ff);

    (int) P_IDE_Adr = (int) TIDE_CYLLOW;
    *P_IDE_Adr = ((LBA_Adress & 0x0000ff00) >> 8);

    (int) P_IDE_Adr = (int) TIDE_CYLHI;
    *P_IDE_Adr = ((LBA_Adress & 0x00ff0000) >> 16);

    (int) P_IDE_Adr = (int) TIDE_DRVHEAD;
    *P_IDE_Adr = (((LBA_Adress & 0xff000000) >> 24) | 0xe0);

    (int) P_IDE_Adr = (int) TIDE_COMMAND;
    *P_IDE_Adr = 0x20;

        IDE_WaitForDRQ();
        WorkCounter2 = 0;
        while (WorkCounter2<512)
        {
            (int) P_IDE_Adr = (int) TIDE_DATAREGLO;
            WorkWord = (*P_IDE_Adr<<8);

            (int) P_IDE_Adr = (int) TIDE_DATAREGHI;
            WorkWord+= *P_IDE_Adr;

            WorkCounter2+=2;

            MP3DEC_SendWord(WorkWord);
        }

    IDE_WaitWhileBusy();
    IDE_WaitForReady();
}

