//
//                 AVRMP3Car - Standalone MP3-Player
//                          Version 2.00 - experimental!   
// written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
//
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation - version 2.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License in file COPYING for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//Please report any bug/fix, modification, suggestion to
//
//           skymab@gmx.de
//
//--------------------------------------------------------------------
/*
    Title:    MP3-Player with ATMEGA 103
    Author:   Pototschnig Thomas
    Date:     Jan 00
*/

#include <io.h>
#include "global.h"
#include "sram.h"
#include "lcd240.h"
#include "port.h"
#include "ide.h"
#include "fat32.h"
#include "mcu.h"
#include "button.h"
#include "mp3dec.h"
#include "dir.h"



/*-------------------------------------------------------------------
  Main-Einsprungspunkt
-------------------------------------------------------------------*/
int main(void)
{

    MCU_Wait(255);                      // annhernd 255ms warten

    PORT_InitPorts();

    LCD240_InitLCD();
    Button_DisplayDirectoryButtons();

    IDE_Autodetect();

    FAT32_ReadBPB();

    DIR_EventLoop();
    LCD240_ClearText();

    MP3DEC_PlaySong();


    LCD240_OutStringXY(0,0,"Ok. Routine finished!");

    for (;;)
    {
    }

    return 0;

}
